﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.FullScreenEvent;
	import caurina.transitions.Tweener;

	public class Damier extends Sprite
	{
		private var col:Number = 2;
		private var line:Number = 1;
		private var nbrBebete:Number = 10;
		private var grid:Sprite;
		private var bebete:Sprite;
		private var points:Array;
		private var amplitude:Number = 700;
		private var diametre:Number = 80;
		
		public function Damier()
		{
			
			grid = new Sprite();
			grid.x = 0;
			grid.y = 0;
			grid.rotation = Math.random() * 360;
			addChild(grid);
			addEventListener (MouseEvent.MOUSE_OVER,bebeteMove);			
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}

		private function bebeteMove (event:MouseEvent){
			var bougeX:Number=(Math.random()*10)*20;
			var posNegX:Number=(Math.random()-0.5);
			var bougeY:Number=(Math.random()*10)*20;
			var posNegY:Number=(Math.random()-0.5);
			Tweener.addTween(grid, {x:posNegX*bougeX, time:.5, transition:"easeInQuart"});
			Tweener.addTween(grid, {y:posNegY*bougeY, time:.5, transition:"easeInQuart"});
		}
		
		private function enterHandler(e:Event):void
		{
			var dist:Number;
			var distx:Number;
			var disty:Number;
			points = new Array();
			for (var i:Number = 0; i<col; i++)
			{
				for (var j:Number = 0; j<line; j++)
				{
					dist = Math.sqrt(Math.pow((j*50-mouseX+grid.x),2) + Math.pow(i*50-mouseY+grid.y,2));
					if (dist < diametre && dist >= 10)
					{
						distx= ((j*50)-mouseX+grid.x<0)?-dist:dist;
						disty= ((i*50)-mouseY+grid.x<0)?-dist:dist;
						points.push({"x":j*50+amplitude/distx+Math.random()*10,"y":i*50+amplitude/disty+Math.random()*10});
					}
					else
					{
						points.push({"x":j*50+Math.random()*10,"y":i*50+Math.random()*10});
					}
				}
			}
			grid.graphics.clear();
			grid.graphics.lineStyle(1,0xffffff);
			for (var k:Number=0; k<points.length; k++)
			{
				grid.graphics.beginFill(0xffffff);
				grid.graphics.drawCircle(points[k].x,points[k].y,10);
				grid.graphics.endFill();
				if ((k+1)%col != 0)
				{
					grid.graphics.moveTo(points[k].x,points[k].y);
					grid.graphics.lineTo(((points[k].x+points[k+1].x)/2)+Math.random()/(points[k].x-mouseX),((points[k].y+points[k+1].y))/2+Math.random()/(points[k].y-mouseY));
					grid.graphics.lineTo(points[k+1].x,points[k+1].y);
				}
				if (k + col < col * line)
				{
					grid.graphics.moveTo(points[k].x,points[k].y);
					grid.graphics.lineTo(((points[k].x+points[k+col].x)/2)+Math.random()/(points[k].x-mouseX),(points[k].y+points[k+col].y)/2+Math.random()/(points[k].y-mouseY));
					grid.graphics.lineTo(points[k+col].x,points[k+col].y);
				}
			}
		}
	}
}